%%% Train and ARIMAX model on some data sequences and make predictions
%%% Sadegh M. Spring 2018, BGL Prediction Project

%% PARAMETERS
seq_len = 48; % expected sequence length
pred_horizon = 30; 
num_patients = 10;
p = 1; % ARIMA p
d = 0; % ARIMA D
q = 0; % ARIMA q

%%
% load X and Y from files
%rmse_list = NaN(num_patients, 1);
hor = floor(pred_horizon / 5);

for pid=1:10
    X = dlmread(sprintf('../Data/ForARIMA/aida/aida_nowhatif_X_%dmin_%d', pred_horizon, pid), ' ');
    Y = dlmread(sprintf('../Data/ForARIMA/aida/aida_nowhatif_Y_%dmin_%d', pred_horizon, pid), ' ');

    N = length(X);
    D = floor(length(X(1, :)) / seq_len);

    for n = 1:N
        if mod(n, 10) == 1
            fprintf('Examples %d..%d for patient %d\n', n, n+9, pid);
        end
        x = X(n, :);
        x = reshape(x, [D, seq_len])';
        est_mdl = estimate(arima(p, d, q), x(4:48, 1), 'X', x(:, 2:4)+1, 'Display', 'off');
        tmp_p = forecast(est_mdl, hor, 'Y0', x(:, 1), 'X0', x(:, 2:4)+1, 'XF', ones(hor, 3));
        preds(n) = tmp_p(end);
    end
    rmse_list(pid) = sqrt(mean((preds(1:N)' - Y) .^ 2));
    fprintf('RMSE: %0.2f\n\n', rmse_list(pid));
end